
/*** Generated through Lumonix shaderFX  by: anval in 3dsmax at: 02.06.2009 10:51:16  ***/ 

// This FX shader was built to support the Quest3D engine. 
// Tell the app that we want tangets 
int UseTangent : UseTangent; 
int UseBiNormal : UseBiNormal; 
 


texture TextureMap_LighthMap : TEXTURE0
<
	string ResourceType = "2D";
>;
 
sampler2D TextureMap_LighthMapSampler = sampler_state
{
	Texture = <TextureMap_LighthMap>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = WRAP;
	AddressV = WRAP;
};
 
texture TextureMap_Dif1 : TEXTURE1
<
	string ResourceType = "2D";
>;
 
sampler2D TextureMap_Dif1Sampler = sampler_state
{
	Texture = <TextureMap_Dif1>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
	AddressU = WRAP;
	AddressV = WRAP;
};
 
texture TextureMap_Dif2 : TEXTURE2
<
	string ResourceType = "2D";
>;
 
sampler2D TextureMap_Dif2Sampler = sampler_state
{
	Texture = <TextureMap_Dif2>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
	AddressU = WRAP;
	AddressV = WRAP;
};
 
float UIConst_913 :CHANNELVALUE0
<
	string UIWidget = "Slider";
	float UIMin = -999.0;
	float UIMax = 999.0;
	float UIStep = 0.1;
	string UIName = "ConstantX";
> = 1.0;
 
float UIConst_1751 :CHANNELVALUE1
<
	string UIWidget = "Slider";
	float UIMin = -999.0;
	float UIMax = 999.0;
	float UIStep = 0.1;
	string UIName = "ConstantZ";
> = 1.0;
 
float UIConst_3536 :CHANNELVALUE2
<
	string UIWidget = "Slider";
	float UIMin = -999.0;
	float UIMax = 999.0;
	float UIStep = 0.1;
	string UIName = "Scale";
> = 1.0;
 
texture TextureBlend : TEXTURE3
<
	string ResourceType = "2D";
>;
 
sampler2D TextureBlendSampler = sampler_state
{
	Texture = <TextureBlend>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = WRAP;
	AddressV = WRAP;
};
 
texture TextureMap_Dif3 : TEXTURE4
<
	string ResourceType = "2D";
>;
 
sampler2D TextureMap_Dif3Sampler = sampler_state
{
	Texture = <TextureMap_Dif3>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
	AddressU = WRAP;
	AddressV = WRAP;
};
 
texture TextureMap_HeightBlue : TEXTURE5
<
	string ResourceType = "2D";
>;
 
sampler2D TextureMap_HeightBlueSampler = sampler_state
{
	Texture = <TextureMap_HeightBlue>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = WRAP;
	AddressV = WRAP;
};
 
float Push :CHANNELVALUE3
<
	string UIWidget = "Slider";
	float UIMin = 0.0;
	float UIMax = 999.0;
	float UIStep = 0.1;
	string UIName = "Push";
> = 5.0;
 

// this function does the different types of light attenuation 
float attenuation_func(int attenType, float4 lightAttenuation, float3 lightVec) 
{ 
	float att = 1.0; 
	return att; 
} 
	 
// this function does the different types of cone angle 
float coneangle_func(int coneType, float lightHotspot, float lightFalloff, float3 lightVec, float3 lightDir) 
{ 
	float cone = 1.0; 
	return cone; 
} 

/************** light info **************/ 

#define MAX_LIGHTCOUNT 8
float NLIGHTS = 1; 
#define LIGHT_TYPE_NONE 0 
#define LIGHT_TYPE_POINT 1 
#define LIGHT_TYPE_SPOT 2 
#define LIGHT_TYPE_DIRECTIONAL 3 
 
float3 light_dir[MAX_LIGHTCOUNT]		: LIGHTDIR; 
float3 light_pos[MAX_LIGHTCOUNT]		: LIGHTPOS; 
float4 light_color[MAX_LIGHTCOUNT]		: LIGHTCOLOR; 
float light_atten1[MAX_LIGHTCOUNT]		: LIGHTATT1; 
float light_atten2[MAX_LIGHTCOUNT]		: LIGHTATT2; 
float light_atten3[MAX_LIGHTCOUNT]		: LIGHTATT3; 
float light_hotspot[MAX_LIGHTCOUNT]		: LIGHTPHI; 
float light_falloff[MAX_LIGHTCOUNT]		: LIGHTTHETA; 
float light_type[MAX_LIGHTCOUNT]		: LIGHTTYPE; 
#define light1attenType 0
#define light1coneType 0
#define light1CastShadows false

//---------------------------------- 

float4x4 wvp : WorldViewProjection < string UIWidget = "None"; >;  
float4x4 worldI : WorldInverse < string UIWidget = "None"; >;  
// create the light vector 
float3 lightVec_func(float3 worldSpacePos, float3 lightVector, float3x3 objTangentXf, int lightType) 
{ 
	float3 lightVec = mul(objTangentXf, (mul((lightVector - worldSpacePos), worldI).xyz)); 
	return lightVec; 
} 

// input from application 
	struct a2v { 
	float4 position		: POSITION; 

	float2 texCoord		: TEXCOORD0; 
	float2 texCoord1	: TEXCOORD1; 
	float4 normal		: NORMAL; 
	float4 binormal		: BINORMAL; 
	float4 tangent		: TANGENT; 

}; 

// output to fragment program 
struct v2f { 
        float4 position    		: POSITION; 

	float2 texCoord			: TEXCOORD0; 
	float2 texCoord1		: TEXCOORD1; 

}; 

v2f av(a2v In, uniform float3 lightPosition, uniform int lightType, uniform float3 lightDirection) 
{ 
	v2f Out = (v2f)0; 

	/*============================= Custom Vertex Shader Code =============================*/ 
	float3 VertPos = In.position.xyz; 
	Out.texCoord = In.texCoord;						//pass through texture coordinates from channel 1 
	float2 IncomingUVCoords = In.texCoord.xy; 
	float MathOperator_6807 = UIConst_913 + IncomingUVCoords.x;
	float ModifiedVCoord = IncomingUVCoords.y + UIConst_1751;
	float2 NewUVs = float2(MathOperator_6807, ModifiedVCoord);
	float2 MathOperator_2788 = IncomingUVCoords * UIConst_3536;
	float2 MathOperator_9632 = NewUVs + MathOperator_2788;
	float4 TextureMap_HeightBlue = tex2Dlod(TextureMap_HeightBlueSampler, float4(In.texCoord.xy,0,0) );
	float3 Normal = In.normal.xyz; 
	float3 Color_X_Normal = TextureMap_HeightBlue.b * Normal;
	float3 Displace = Color_X_Normal * Push;
	float3 NewPos = VertPos + Displace;
	In.position.xyz = NewPos;
	/*=====================================================================================*/ 


    Out.position = mul(In.position, wvp);				//transform vert position to homogeneous clip space 

	Out.texCoord1 = In.texCoord1;						//pass through texture coordinates from channel 2 

    return Out; 
} 

	//Single Pass Pixel Shader
float4 af(v2f In, uniform float3 lightDir, uniform float4 lightColor, uniform float4 lightAttenuation, uniform float lightHotspot, uniform float lightFalloff, uniform int lightType, uniform int attenType, uniform int coneType, uniform bool castShadows, uniform int shadowPassCount) : COLOR 
{ 

	float4 TextureMap_LighthMap = tex2D(TextureMap_LighthMapSampler, In.texCoord.xy);
	float4 TextureMap_Dif1 = tex2D(TextureMap_Dif1Sampler, In.texCoord1.xy);
	float4 TextureMap_Dif2 = tex2D(TextureMap_Dif2Sampler, In.texCoord1.xy);
	float2 IncomingUVCoords = In.texCoord.xy; 
	float MathOperator_6807 = UIConst_913 + IncomingUVCoords.x;
	float ModifiedVCoord = IncomingUVCoords.y + UIConst_1751;
	float2 NewUVs = float2(MathOperator_6807, ModifiedVCoord);
	float2 MathOperator_2788 = IncomingUVCoords * UIConst_3536;
	float2 MathOperator_9632 = NewUVs + MathOperator_2788;
	float4 TextureBlend = tex2D(TextureBlendSampler, MathOperator_9632.xy);
	float3 BlendDiffuse1 = lerp(TextureMap_Dif1.rgb, TextureMap_Dif2.rgb, TextureBlend.r); 
	float4 TextureMap_Dif3 = tex2D(TextureMap_Dif3Sampler, In.texCoord1.xy);
	float3 BlendDif2 = lerp(BlendDiffuse1, TextureMap_Dif3.rgb, TextureBlend.g); 
	float3 MathOperator_4763 = TextureMap_LighthMap.rgb * BlendDif2;
	float3 input1 = MathOperator_4763; 

	float4 ret =  float4(input1, 1); 
	return ret; 
} 

technique Complete  
{  
	pass ambient  
    {		 
		VertexShader = compile vs_3_0 av(light_pos[0], light_type[0], light_dir[0]); 
		ZEnable = true; 
		ZWriteEnable = true; 
		CullMode = ccw; 
		ShadeMode = Gouraud;
		AlphaBlendEnable = false; 
		AlphaTestEnable = FALSE; 
		PixelShader = compile ps_3_0 af(light_dir[0], light_color[0], float4(light_atten1[0], light_atten2[0], light_atten3[0], 1.0), light_hotspot[0], light_falloff[0], light_type[0], light1attenType, light1coneType, light1CastShadows, 1); 
	}  

}    